using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Collections;

namespace TestSyncfusionIssue {
	public partial class Form1: Form {
		public Form1 () {
			InitializeComponent();

		}

		protected override void OnLoad (EventArgs e) {
			base.OnLoad(e);

			List<NewPatient> list = new List<NewPatient>();
			NewPatient p1 = new NewPatient();
			p1.Name = "foo";
			p1.TestEmployer = new NewCompany();
			p1.TestEmployer.Name = "empfoo";
			//p1.TestEmployer.TestPatient = new NewPatient();
			//p1.TestEmployer.TestPatient.Name = "Test";
			//p1.TestEmployer.TestPatient.TestEmployer = p1.TestEmployer;

			list.Add(p1);

			_testGrid.ShowNestedPropertiesFields = false;
			
			//_testGrid.TableDescriptor.Fields.Clear();
			//_testGrid.TableDescriptor.Fields.Add("Name");
			//_testGrid.TableDescriptor.Fields.Add("TestEmployer.Name");
			//_testGrid.TableDescriptor.Fields.Add("TestEmployer.TestPatient");
			//_testGrid.TableDescriptor.Fields.Add("TestEmployer.TestPatient.TestEmployer");
			// or 
			//_testGrid.TableDescriptor.Fields.Add("TestEmployer.TestPatient.Name");


			FieldDescriptorCollection fields = _testGrid.TableDescriptor.Fields;
			fields.Clear();

			PropertyDescriptorCollection pdc = ListUtil.GetItemProperties(list);
			for (int n = pdc.Count-1; n >= 0; n--)
			{
				PropertyDescriptor pd = pdc[n];

				if (ListUtil.IsComplexType(pd))
				{
					// put here condition when to include nested properties.
					AddNestedProperties(fields, pd.Name, pd.PropertyType, 0);
				}
				else
					fields.Add(pd.Name);
			}

			_testGrid.DataSource = list;

			//_testGrid.Engine.QueryShowNestedPropertiesFields += new Syncfusion.Grouping.QueryShowNestedPropertiesFieldsEventHandler(Engine_QueryShowNestedPropertiesFields);
			//_testGrid.Engine.QueryShowRelationDisplayFields += new QueryShowRelationFieldsEventHandler(Engine_QueryShowRelationDisplayFields);
			//_testGrid.Engine.QueryAddRelation += new QueryAddRelationEventHandler(Engine_QueryAddRelation);

			//GridRelationDescriptor rd = new GridRelationDescriptor();
			//rd.MappingName = "TestEmployer";
			//rd.RelationKind = RelationKind.ListItemReference;
			//_testGrid.TableDescriptor.Relations.Add(rd);
		}


		void AddNestedProperties(FieldDescriptorCollection fields, string prefix, Type propertyType, int level)
		{
			PropertyDescriptorCollection pdc = ListUtil.GetItemProperties(propertyType);
			if (pdc.Count > 0)
			{
				foreach (PropertyDescriptor pd in pdc)
				{
					// Add here criteria when to step into nested type.
					if (ListUtil.IsComplexType(pd) && level < 2)
						AddNestedProperties(fields, prefix + "." + pd.Name, pd.PropertyType, level+1);
					else
						fields.Add(prefix + "." + pd.Name);
				}
			}
		}

		void Engine_QueryAddRelation(object sender, QueryAddRelationEventArgs e)
		{
			Console.WriteLine("Engine_QueryAddRelation " + e.ToString());
		}

		void Engine_QueryShowRelationDisplayFields(object sender, QueryShowRelationFieldsEventArgs e)
		{
			Console.WriteLine("Engine_QueryShowRelationDisplayFields " + e.ToString());
		}

		void Engine_QueryShowNestedPropertiesFields(object sender, Syncfusion.Grouping.QueryShowNestedPropertiesFieldsEventArgs e)
		{
			Console.WriteLine("QueryShowNestedPropertiesFields " + e.ToString());
		}
	}

	public class NewPatient {
		private NewCompany _employer;
		private string _name = "";

		#region Accessors
		public NewPatient () {
		//	MessageBox.Show("NewPatient instantiating");
		}

		public NewCompany TestEmployer
		{
			get { return _employer; }
			set { _employer = value; }
		}

		public string Name {
			get { return _name; }
			set { _name = value; }
		}
		#endregion
	}

	public class NewCompany {
		private string _name;

		public NewCompany () {
			//MessageBox.Show("NewCompany instantiating");
		}

		public string Name {
			get { return _name; }
			set { _name = value; }
		}

		//[Browsable(false)]
		public NewPatient TestPatient
		{
			get { return null; }
			set { }
		}
	}
}